class Time:
    def __init__(self,*args):
        """
        Time class constructor
        variable number of input parameters
        1 parameter - a string h:m is expected
        2 parameters - h,m (hours, minutes)
        """
        self._h,self._m = self.__process_inputs(*args)

    def __process_inputs(self,*args):
        if len(args)>2:
            raise ValueError("{} is not valid set of paramters, see: {}".
                             format(str(args),Time.__init__.__doc__))
        if len(args)==1:
            if not isinstance(args[0],str):
                raise ValueError('error')
            strvalues = args[0].split(":")
            values = [int(x) for x in strvalues]
        else:
            values = args

        h = 0
        m = values[1]
        if m >= 60:
            print("Warning: minutes >= 60, correcting ...")
            h_increment = m // 60
            h += h_increment
            m = m - h_increment*60 

        h += values[0]
        assert h <= 24 and h >= 0, "0<=hours<=24, which is not, hours value is: {}".format(h)
        return h,m
        
    def __abs__(self):
        return self._h*60 + self._m

    def __lt__(self,other):
        return abs(self)<abs(other)
    def __le__(self,other):
        return abs(self)<=abs(other)
    def __eq__(self,other):
        return abs(self)==abs(other)
    def __ne__(self,other):
        return abs(self)!=abs(other)
    def __ge__(self,other):
        return abs(self)>=abs(other)
    def __gt__(self,other):
        return abs(self)>abs(other)
    
    def __sub__(self,other):
        assert self>=other, "Time difference is assumed to positive, which is not for {}-{}".format(str(self),str(other))
        diff_in_min = abs(self)-abs(other)
        return mins_to_Time(diff_in_min)
    
    def __str__(self):
        return "{:02d}:{:02d}".format(self._h,self._m)

def mins_to_Time(mins):
    h = mins // 60
    m = mins - h*60
    return Time(h,m)
    
if __name__ == "__main__":
    try:
        t0 = Time(3,4,5)
    except:
        print("Warning, a strange time needed")
        t0 = Time(0,0)
    t2 = Time(21,66)
    t1 = Time("0:0")
    print(t1,t2)
    try:
        t3 = t2-t1
    except AssertionError as err:
        print("Warning: {}".format(err))
        t3 = Time(0,0)
        
    print("t2-t1 = t3; {} - {} ={}".format(str(t2),str(t1),str(t3)))

